package com.yuxingwang.gantt.demo.tabs;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.DefaultMutableTreeNode;

import org.apache.log4j.Logger;

import com.yuxingwang.gantt.common.EventLogger;
import com.yuxingwang.gantt.common.ExTree;
import com.yuxingwang.gantt.demo.GanttChartDemoComponent;
import com.yuxingwang.gantt.event.SelectionChangeEvent;
import com.yuxingwang.gantt.event.SelectionChangeListener;
import com.yuxingwang.gantt.model.Task;
import com.yuxingwang.gantt.model.TaskTreeModel;
import com.yuxingwang.gantt.ui.TimeUnit;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ScheduleTab extends BaseTab {
	/**
	 * Logger for this class
	 */
	private static final Logger logger = Logger.getLogger(ScheduleTab.class);

	private static final long serialVersionUID = 1L;
	private JPanel tabPane = null; //  @jve:decl-index=0:visual-constraint="10,10"
	private ExTree taskTree = null;
	private JPanel jPanel = null;
	private JButton btnAddTaskToRoot = null;
	private JButton btnAddTaskToSelectTask = null;
	private JButton btnRemoveTask = null;
	private JButton btnEditSelectedTask = null;

	//
	private GanttChartDemoComponent ganttComp = null;
	private JComboBox cmbTimeUnit = null;
	private JButton btnRemoveAllTasks;
	private JLabel jLabel = null;
	private JPanel jPanel1 = null;

	public ScheduleTab() {
		super();
	}

	public ScheduleTab(GanttChartDemoComponent gantt) {
		this.ganttComp = gantt;
		this.ganttComp.addSelectionChangeListener(new SelectionChangeListener() {
			public void selectionChanged(SelectionChangeEvent e) {
				Task task = e.getSelection();
				getTaskTree().select(task);
				if (task != null) {
					getTaskTree().expandTreeNode(task);
				}
				getTaskTree().updateUI();
			}
		});
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setSize(new Dimension(694, 287));
		this.setPreferredSize(new java.awt.Dimension(694, 303));
		this.setViewportView(getTabPane());
	}

	public void setTaskTreeModel(TaskTreeModel taskTreeModel) {
		this.taskTree.setTreeModel(taskTreeModel);
		taskTreeModel.addTreeModelListener(new javax.swing.event.TreeModelListener() {
			public void treeNodesChanged(TreeModelEvent e) {
				EventLogger.event(e, "treeNodesChanged()");
				//				getGantt().update(getGantt().getGraphics());
				//				getGantt().updateUI();
			}

			public void treeNodesInserted(TreeModelEvent e) {
				EventLogger.event(e, "treeNodesInserted()");
				//				getGantt().update(getGantt().getGraphics());
				//				getGantt().updateUI();
			}

			public void treeNodesRemoved(TreeModelEvent e) {
				EventLogger.event(e, "treeNodesRemoved()");
				//				getGantt().update(getGantt().getGraphics());
				//				getGantt().updateUI();
			}

			public void treeStructureChanged(TreeModelEvent e) {
				EventLogger.event(e, "treeStructureChanged()");
				//				getGantt().update(getGantt().getGraphics());
				//				getGantt().updateUI();
			}
		});
		//        System.err.println("[setTaskTreeModel] Is TaskTreeModel?" + (taskTree.getTreeModel() instanceof TaskTreeModel));
		this.taskTree.expandAllTreeNode((DefaultMutableTreeNode) taskTreeModel.getRoot());
	}

	/**
	 * This method initializes tabPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getTabPane() {
		if (tabPane == null) {
			tabPane = new JPanel();
			tabPane.setLayout(null);
			tabPane.setSize(new Dimension(685, 211));
			tabPane.add(getTaskTree(), null);
			tabPane.add(getJPanel(), null);
			tabPane.add(getJPanel1(), null);
			tabPane.addComponentListener(new java.awt.event.ComponentAdapter() {
				public void componentResized(java.awt.event.ComponentEvent e) {
					EventLogger.event(e, "componentResized()");
					getJPanel().setLocation(tabPane.getWidth() - getJPanel().getWidth() - 8, getJPanel().getY());
					getJPanel1().setLocation(tabPane.getWidth() - getJPanel().getWidth() - 8, getJPanel1().getY());
					getTaskTree().setSize(getJPanel().getLocation().x, tabPane.getHeight());
				}
			});
		}
		return tabPane;
	}

	/**
	 * This method initializes TaskTree
	 * 
	 * @return javax.swing.JTree
	 */
	private ExTree getTaskTree() {
		if (taskTree == null) {
			taskTree = new ExTree();
			taskTree.setSize(new Dimension(213, 169));
			taskTree.setLocation(new Point(0, 0));
		}
		return taskTree;
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel = new JLabel();
			jLabel.setText("Time Unit:");
			jLabel.setBounds(new Rectangle(14, 11, 166, 18));
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setBounds(486, 95, 190, 194);
			jPanel.add(getBtnAddTaskToRoot(), null);
			jPanel.add(getBtnAddTaskToSelectTask(), null);
			jPanel.add(getBtnRemoveTask(), null);
			jPanel.add(getBtnEditSelectedTask(), null);
			jPanel.add(getBtnRemoveAllTasks());
		}
		return jPanel;
	}

	/**
	 * This method initializes btnAddTaskToRoot
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnAddTaskToRoot() {
		if (btnAddTaskToRoot == null) {
			btnAddTaskToRoot = new JButton();
			btnAddTaskToRoot.setBounds(10, 0, 170, 28);
			btnAddTaskToRoot.setText("Add Task to Root");
			btnAddTaskToRoot.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					TaskDialog td = new TaskDialog();
					td.setVisible(true);
					// Root node isn't a Task node.
					TaskTreeModel ttm = (TaskTreeModel) getTaskTree().getTreeModel();
					ttm.add(td.getTask());
					getTaskTree().updateUI();
				}
			});
		}
		return btnAddTaskToRoot;
	}

	/**
	 * This method initializes btnAddTaskToSelectTask
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnAddTaskToSelectTask() {
		if (btnAddTaskToSelectTask == null) {
			btnAddTaskToSelectTask = new JButton();
			btnAddTaskToSelectTask.setBounds(10, 82, 170, 28);
			btnAddTaskToSelectTask.setText("Add Task to Selection");
			btnAddTaskToSelectTask.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					Task selectedTask = (Task) getTaskTree().getSelectedNode();
					if (selectedTask == null) {
						return;
					}
					TaskDialog td = new TaskDialog();
					td.setVisible(true);
					TaskTreeModel model = (TaskTreeModel) getTaskTree().getTreeModel();
					model.addTo(selectedTask, td.getTask());
					getTaskTree().expandTreeNode(selectedTask);
					getTaskTree().updateUI();
				}
			});
		}
		return btnAddTaskToSelectTask;
	}

	/**
	 * This method initializes btnRemoveTask
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnRemoveTask() {
		if (btnRemoveTask == null) {
			btnRemoveTask = new JButton();
			btnRemoveTask.setBounds(10, 123, 170, 28);
			btnRemoveTask.setText("Remove Selected Task");
			btnRemoveTask.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					Task selectedTask = (Task) getTaskTree().getSelectedNode();
					if (selectedTask == null) {
						return;
					}
					((TaskTreeModel) getTaskTree().getTreeModel()).removeTask(selectedTask);
				}
			});
		}
		return btnRemoveTask;
	}

	/**
	 * This method initializes btnEditSelectedTask
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtnEditSelectedTask() {
		if (btnEditSelectedTask == null) {
			btnEditSelectedTask = new JButton();
			btnEditSelectedTask.setBounds(10, 41, 170, 28);
			btnEditSelectedTask.setText("Edit Selected Task");
			btnEditSelectedTask.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					Task selectedTask = (Task) getTaskTree().getSelectedNode();
					if (selectedTask == null) {
						return;
					}
					ganttComp.suspendUI();
					TaskDialog td = new TaskDialog(selectedTask);
					td.setVisible(true);// Display
					selectedTask.copy(td.getTask());
					getTaskTree().updateUI();
					ganttComp.resumeUI();
				}
			});
		}
		return btnEditSelectedTask;
	}

	public GanttChartDemoComponent getGantt() {
		return ganttComp;
	}

	//	public void setGantt(GanttChartDemoControl gantt) {
	//		this.gantt = gantt;
	//
	//	}

	/**
	 * This method initializes cmbTimeUnit
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getCmbTimeUnit() {
		if (cmbTimeUnit == null) {
			cmbTimeUnit = new JComboBox();
			cmbTimeUnit.setBounds(new Rectangle(15, 38, 170, 28));
			String[] ckbList = new String[] { "Hour", "AllDay", "Day", "Week", "Month", "Year" };
			DefaultComboBoxModel model = new DefaultComboBoxModel(ckbList);
			cmbTimeUnit.setModel(model);
			int index = 0;
			if (getGantt().getTimeUnit() == TimeUnit.Hour) {
				index = 0;
			} else if (getGantt().getTimeUnit() == TimeUnit.AllDay) {
				index = 1;
			} else if (getGantt().getTimeUnit() == TimeUnit.Day) {
				index = 2;
			} else if (getGantt().getTimeUnit() == TimeUnit.Week) {
				index = 3;
			} else if (getGantt().getTimeUnit() == TimeUnit.Month) {
				index = 4;
			} else if (getGantt().getTimeUnit() == TimeUnit.Year) {
				index = 5;
			}
			cmbTimeUnit.setSelectedIndex(index);
			cmbTimeUnit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					if (cmbTimeUnit.getSelectedItem().equals("Hour")) {
						ganttComp.initHourlyModel();
					} else if (cmbTimeUnit.getSelectedItem().equals("AllDay")) {
						ganttComp.initAllDayModel();
					} else if (cmbTimeUnit.getSelectedItem().equals("Day")) {
						ganttComp.initDailyModel();
					} else if (cmbTimeUnit.getSelectedItem().equals("Week")) {
						ganttComp.initWeeklyModel();
					} else if (cmbTimeUnit.getSelectedItem().equals("Month")) {
						ganttComp.initMonthlyModel();
					} else if (cmbTimeUnit.getSelectedItem().equals("Year")) {
						ganttComp.initYearModel();
					}
					taskTree.setTreeModel(ganttComp.getGanttModel().getTaskTreeModel());
					taskTree.updateUI();
					taskTree.expandAllTreeNode((DefaultMutableTreeNode) ganttComp.getGanttModel().getTaskTreeModel().getRoot());

				}
			});
		}
		return cmbTimeUnit;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.setBounds(new Rectangle(486, 10, 191, 76));
			jPanel1.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
			jPanel1.add(jLabel, null);
			jPanel1.add(getCmbTimeUnit(), null);
		}
		return jPanel1;
	}
	
	private JButton getBtnRemoveAllTasks() {
		if(btnRemoveAllTasks == null) {
			btnRemoveAllTasks = new JButton();
			btnRemoveAllTasks.setText("Remove All Tasks");
			btnRemoveAllTasks.setBounds(10, 161, 170, 28);
			btnRemoveAllTasks.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					EventLogger.event(e, "actionPerformed()");
					ganttComp.getModel().removeAll();

				}
			});
		}
		return btnRemoveAllTasks;
	}

} //  @jve:decl-index=0:visual-constraint="10,10"
